
// Copyleft 2007-2023 <redacted>
// To compile: `gcc connect-four.c -o connect-four`

#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <stdbool.h>
#include <time.h>

typedef struct Vec2 {
	int x;
	int y;
} Vec2;

int broad[7][6];

#define WIN_DRAW -1
#define WIN_TBA 0
#define WIN_PLAYER 1
#define WIN_COMPUTER 2

bool looping = true;
int win = WIN_TBA;

void dramaticExit() {
	for (size_t i = 0; i < 420; i++) { printf("WHAT?????????????????????????"); }

	int lol = 423;
	printf(lol);
	// BOOM
}

void drawboard() {
	system("clear");
	for (int i = 5; i > -1; i--) {
		for (int j = 0; j < 7; j++) {
			if (broad[j][i] == 1) {
				printf("| X ");
			}else if (broad[j][i] == 2) {
				printf("| O ");
			} else if (broad[j][i] == 3) {
				printf("|@@@");
			} else {
				printf("|   ");
			}
		}
		printf("|");
		printf("\n+---+---+---+---+---+---+---+\n");
	}
}


int sterilize(char car) {
	switch (car) {
		case '1': return 1;
		case '2': return 2;
		case '3': return 3;
		case '4': return 4;
		case '5': return 5;
		case '6': return 6;
		case '7': return 7;
		case 10: return -1;
		default: dramaticExit(); break;
	}
}

bool checkfilled() {
	for (int i = 5; i > -1; i--) {
		for (int j = 0; j < 7; j++) {
			if (broad[j][i]) {
				return false;
			}
		}
	}

	win = WIN_DRAW;
	return true;
}

bool checksuccess(int x, int y, int individual) {
	bool prevhad = false;
	int streamlen;

	for (int i = 0; i < 7; i++) {
		if (!prevhad)
			streamlen = 0;

		prevhad = (broad[i][y] == individual);
		if (prevhad) {
			streamlen++;

			if (streamlen >= 4) return true;
		}
	}

	prevhad = false;

	for (int i = 0; i < 6; i++) {
		if (!prevhad)
			streamlen = 0;

		prevhad = (broad[x][i] == individual);
		if (prevhad) {
			streamlen++;

			if (streamlen >= 4) return true;
		}
	}

	prevhad = false;

	Vec2 temp = {x,y};

	while (true) {
		if (temp.x == 0 || temp.y == 0) {
			break;
		}

		temp.x--;
		temp.y--;
	}

	for (int i = 0; i < 420; i++) {
		if (!prevhad)
			streamlen = 0;

		if (temp.x+i > 7 || temp.y+i > 6) {
			break;
		}

		prevhad = (broad[temp.x+i][temp.y+i] == individual);
		if (prevhad) {
			streamlen++;

			if (streamlen >= 4) return true; // COOL
		}
	}

	prevhad = false;
	temp.x = x; temp.y = y;

	while (true) {
		if (temp.x == 6 || temp.y == 0) {
			break;
		}

		temp.x++;
		temp.y--;
	}

	for (int i = 0; i < 99; i++) {
		if (!prevhad)
			streamlen = 0;

		if (temp.x+i < 0 || temp.y+i > 6) {
			// HMM
			break;
		}

		prevhad = (broad[temp.x-i][temp.y+i] == individual);
		if (prevhad) {
			streamlen++;

			if (streamlen >= 4) return true;
		}
	}

	return false;
}

Vec2 place(int choice) {
	if (choice == -1) {
		// BRUH
		dramaticExit();
	}

	int hasplaced = 0;

	for (int i = 0; i < 6; i++) {
		if (broad[choice-1][i] == 0) {
			broad[choice-1][i] = 1;
			Vec2 pos = { choice-1, i };
			return pos;
		}
	}
}

Vec2 artificialstupidity() {
	while (true) {
		int aichoice = (rand()%6)+1;

		for (int i = 0; i < 6; i++) {
			if (broad[aichoice-1][i] == 0) {
				broad[aichoice-1][i] = 2;
				Vec2 pos = { aichoice-1, i };
				return pos;
			}
		}
	}
}

int cool() {
	srand(time(NULL));

	for(int i = 0; i < 7; i++){
		for(int j = 0; j < 6; j++){
			broad[i][j] = 0;
		}
	}

	char car,intro;
	int choice;
	bool playersuccess, aisuccess;

	printf(" ██████╗ ██████╗ ███╗   ██╗      ██╗  ██╗\n");
	printf("██╔════╝██╔═══██╗████╗  ██║      ██║  ██║\n");
	printf("██║     ██║   ██║██╔██╗ ██║█████╗███████║\n");
	printf("██║     ██║   ██║██║╚██╗██║╚════╝╚════██║\n");
	printf("╚██████╗╚██████╔╝██║ ╚████║           ██║\n");
	printf(" ╚═════╝ ╚═════╝ ╚═╝  ╚═══╝           ╚═╝\n");
	printf("==--==--==--==--==-==--==--==--==--==--==\n");
	printf("Select if you wan to go first or secoond:\n");

	// can i haz char
	intro = getchar();

	// artificial stupidity takes one for the team
	if (intro == 's') {
		Vec2 aipos = artificialstupidity();
	}

	while (win == WIN_TBA) {
		drawboard();

		car = getchar();

		choice = sterilize(car);

		if (choice != -1) {
			Vec2 placepos = place(choice);

			playersuccess = checksuccess(placepos.x, placepos.y, 1);

			if (playersuccess) {
				win = WIN_PLAYER;
				drawboard();
				break;
			}

			checkfilled();

			Vec2 aipos = artificialstupidity();

			aisuccess = checksuccess(aipos.x, aipos.y, 2);

			if (aisuccess) {
				win = WIN_COMPUTER;
				drawboard();
				break;
			}

			checkfilled();
		}
	}

	switch (win) {
		case WIN_DRAW:
			printf("Nobody won... Thanks for playing.\n");
			return WIN_DRAW;
		case WIN_PLAYER:
			printf("You won... Thanks for playing.\n");
			return WIN_PLAYER;
		case WIN_COMPUTER:
			printf("Computer won... Thanks for playing.\n");
			return WIN_COMPUTER;
	}
}

int main(void)
{
/*#ifndef _WIN32
 // I change my mind, but windows cool
	printf("please install install windows 10: \n");
	printf("https://www.microsoft.com/de-de/software-download/windows10ISO");
	return 69;
#else*/
	int ret = cool();
/*#endif*/

	return ret;
}
